<?php

namespace App\Controllers;

class Header extends BaseController
{
    public function header_form()
    {
        $created_by=session()->get('username');
        $header_name=$this->request->getVar('header_name');
        $header_description=$this->request->getVar('header_description');
        if($header_name!='' && $header_description!=''){
            $db=\Config\Database::connect();
            $data=[
                'header_name'=>$header_name,
                'header_description'=>$header_description,
                'created_by'=>$created_by,
                'created_at' => date('Y-m-d H:i:s')
            ];
            $builder=$db->table('header');
            $insert=$builder->insert($data);
            if($insert){
                return $this->response->setJSON(['result'=>1,'message'=>'Header created successfully']);
            }else{
                return $this->response->setJSON(['result'=>0,'message'=>'Failed to create Header']);
            }
        }else{
            return $this->response->setJSON(['result'=>0,'message'=>'please fill the neccessary feileds']);
        } 
    }
    public function expense_form()
    {
        $created_by=session()->get('username');
        $expense_name=$this->request->getVar('expense_name');
        $description=$this->request->getVar('description');
        if($expense_name!='' && $description!=''){
            $db=\Config\Database::connect();
            $data=[
                'expense_name'=>$expense_name,
                'description'=>$description,
                'created_by'=>$created_by,
                'created_at' => date('Y-m-d H:i:s')
            ];
            $builder=$db->table('expense_type');
            $insert=$builder->insert($data);
            if($insert){
                return $this->response->setJSON(['result'=>1,'message'=>'Expense created successfully']);
            }else{
                return $this->response->setJSON(['result'=>0,'message'=>'Failed to create Expense']);
            }
        }else{
            return $this->response->setJSON(['result'=>0,'message'=>'please fill the neccessary feileds']);
        } 
    }
    public function header_data()
    {
        $id=session()->get('id');
        if($id){
            $db=\Config\Database::connect();
            $builder=$db->table('header');
            $data=$builder->get()->getResultArray();
            if($data){
                return $this->response->setJSON($data);
            }else{
                return $this->response->setJSON(['result'=>0,'message'=>'Failed to load data']);
            }
        }
    }

    public function expense_data()
    {
        $id=session()->get('id');
        if($id){
            $db=\Config\Database::connect();
            $builder=$db->table('expense_type');
            $data=$builder->get()->getResultArray();
            if($data){
                return $this->response->setJSON($data);
            }else{
                return $this->response->setJSON(['result'=>0,'message'=>'Failed to load data']);
            }
        }
    }

    public function header_value()
    {
        $id=$this->request->getVar('id');

        if($id){
            $db=\Config\Database::connect();
            $builder=$db->table('header_value');
            $builder->where('header_id',$id);
            $data=$builder->get()->getResultArray();
            if($data){
                return $this->response->setJSON(['result'=>1,'data'=>$data]);
            }else{
                return $this->response->setJSON(['result'=>0,'message'=>'No data present in this Header']);
            }
        }else{
            return $this->response->setJSON(['result'=>0,'message'=>'Please Login']);
        }
    }
    public function header_delete()
    {
        $id=$this->request->getVar('id');
        // echo $id;die();
        $db=\Config\Database::connect();
        $builder=$db->table('header');
        $builder->where('id',$id);
        $delete=$builder->delete();
        if($delete){
            return $this->response->setJSON(['result'=>1]);
        }else{
            return $this->response->setJSON(['result'=>0]);
        }
    }
    public function expense_delete()
    {
        $id=$this->request->getVar('id');
        // echo $id;die();
        $db=\Config\Database::connect();
        $builder=$db->table('expense_type');
        $builder->where('id',$id);
        $delete=$builder->delete();
        if($delete){
            return $this->response->setJSON(['result'=>1]);
        }else{
            return $this->response->setJSON(['result'=>0]);
        }
    }
    public function value_delete()
    {
        $id=$this->request->getVar('id');
        // echo $id;die();
        $db=\Config\Database::connect();
        $builder=$db->table('header_value');
        $builder->where('id',$id);
        $delete=$builder->delete();
        if($delete){
            return $this->response->setJSON(['result'=>1]);
        }else{
            return $this->response->setJSON(['result'=>0]);
        }
    }
    public function value_form()
    {
        $created_by=session()->get('username');
        $id=$this->request->getVar('id');
        $value_name=$this->request->getVar('value_name');
        $value_description=$this->request->getVar('value_description');
        if($value_name!='' && $value_description!=''){
            $db=\Config\Database::connect();
            $data=[
                'header_id'=>$id,
                'value_name'=>$value_name,
                'value_description'=>$value_description,
                'created_by'=>$created_by,
                'created_at' => date('Y-m-d H:i:s')
            ];
            $builder=$db->table('header_value');
            $insert=$builder->insert($data);
            if($insert){
                return $this->response->setJSON(['result'=>1,'message'=>'Value created successfully']);
            }else{
                return $this->response->setJSON(['result'=>0,'message'=>'Failed to create value']);
            }
        }else{
            return $this->response->setJSON(['result'=>0,'message'=>'please fill the neccessary feileds']);
        } 
    }
    public function update_header()
    {
        $id=$this->request->getVar('headerid');
        $created_by=session()->get('username');
        $header_name=$this->request->getVar('header_name');
        $header_description=$this->request->getVar('header_description');

        // echo $id;die();
        $db=\Config\Database::connect();
        $builder=$db->table('header');
        $data=[
            'header_name'=>$header_name,
            'header_description'=>$header_description,
            'created_by'=>$created_by
        ];
        $builder->where('id',$id);
        $delete=$builder->update($data);
        if($delete){
            return $this->response->setJSON(['result'=>1,'message'=>'Header updated successfully']);
        }else{
            return $this->response->setJSON(['result'=>0,'message'=>'Failed to update']);
        }
    }
    public function update_expense()
    {
        $id=$this->request->getVar('expenseid');
        $created_by=session()->get('username');
        $expense_name=$this->request->getVar('expense_name');
        $description=$this->request->getVar('description');

        // echo $id;die();
        $db=\Config\Database::connect();
        $builder=$db->table('expense_type');
        $data=[
            'expense_name'=>$expense_name,
            'description'=>$description,
            'created_by'=>$created_by
        ];
        // print_r($id );die();
        $builder->where('id',$id);
        $delete=$builder->update($data);
        if($delete){
            return $this->response->setJSON(['result'=>1,'message'=>'Expense updated successfully']);
        }else{
            return $this->response->setJSON(['result'=>0,'message'=>'Failed to update']);
        }
    }
    public function update_value()
    {
        $id=$this->request->getVar('valueid');
        $created_by=session()->get('username');
        $value_name=$this->request->getVar('value_name');
        $value_description=$this->request->getVar('value_description');

        // echo $id;die();
        $db=\Config\Database::connect();
        $builder=$db->table('header_value');
        $data=[
            'value_name'=>$value_name,
            'value_description'=>$value_description,
            'created_by'=>$created_by
        ];
        $builder->where('id',$id);
        $delete=$builder->update($data);
        if($delete){
            return $this->response->setJSON(['result'=>1,'message'=>'Value updated successfully']);
        }else{
            return $this->response->setJSON(['result'=>0,'message'=>'Failed to update']);
        }
    }
}
?>