<?php echo view('includes/home_sidebar');?>


<style>
    #leftDiv {
        height: 960px !important;
    }

    /* button  */
    .repot-btm button {
        background: #97BE5A;
        border: none;
        padding: 20px 20px;
        display: inline-block;
        font-size: 16px;
        font-weight: 600;
        width: 100%;
        text-transform: uppercase;
        cursor: pointer;
        transform: skew(-21deg);
    }

    .repot-btm span {
        display: inline-block;
        transform: skew(21deg);
    }

    .repot-btm button::before {
        content: '';
        position: absolute;
        top: 0;
        bottom: 0;
        right: 100%;
        left: 0;
        background: #00484c;
        opacity: 0;
        z-index: -1;
        transition: all 0.5s;
    }

    .repot-btm button:hover {
        color: #fff;
    }

    .repot-btm button:hover::before {
        left: 0;
        right: 0;
        opacity: 1;
    }
 
    /* button  */
    .rpt-btn-lft{
        margin-left: -25px;
    }

    @media only screen and (max-width: 600px) {
        .repot-btm {
            padding: 10px 30px;
    }
    .rpt-btn-lft{
        margin-left: 0px;
        margin-top: -12px;
    }
    }
</style>

<main id="rightDiv">
    <div class="container-fluid">
        <div class="row">

            <div class="col-sm-12">

                <!-- -------FEE STRUCTURE AND BACK BUTTON---------- -->
                <section class="fee-structure">
                    <h3 style="color: rgba(0, 72, 76, 1);">Reports</h3>
                    <button class="btn back-butt" onclick="goBack()"><i class="fa fa-arrow-left"
                            aria-hidden="true"></i>&nbsp;Back</button>
                </section>
            </div>
        </div>
        <div class="row mt-5 mb-3">
            <div class="col-sm-1"></div>
            <div class="col-sm-3 repot-btm">
                <button onclick="studentReport()">
                    <span>Student Report</span>
                </button>
            </div>
            <div class="col-sm-3 repot-btm">
                <button onclick="feeReport()">
                    <span>Fee Report</span>
                </button>
            </div>
            <div class="col-sm-3 repot-btm">
                <button onclick="leadReport()">
                    <span>Lead Report</span>
                </button>
            </div>
        </div>
        <!--  -->
        <div class="row  mt-2 mb-3">
            <div class="col-sm-1 p-0"></div>
            <div class="col-sm-3 repot-btm rpt-btn-lft">
                <button onclick="expenseReport()">
                    <span>Expense Report</span>
                </button>
            </div>
            <div class="col-sm-3 repot-btm">
                <button onclick="follupReport()">
                    <span>Follow Up Report
 </span>
                </button>
            </div>
            <!-- <div class="col-sm-3 repot-btm">
                <button onclick="leadReport()">
                    <span>Lead report</span>
                </button>
            </div> -->
        </div>
    </div>

</main>
</section>


<script>
    window.onload = function () {
        const leftDiv = document.getElementById('leftDiv');
        const rightDiv = document.getElementById('rightDiv');

        const rightDivHeight = rightDiv.offsetHeight;

        leftDiv.style.height = rightDivHeight + 'px';
    };

</script>
<!-- BACK BUTTON SCRIPT -->
<script>
    function goBack() {
        window.location.href = "<?php echo base_url('dashboard');?>";
    }
</script>
<script>
    function studentReport() {
        window.location.href = "<?php echo base_url('student-report');?>";
    }
</script>
<script>
    function feeReport() {
        window.location.href = "<?php echo base_url('fee-reoprt');?>";
    }
</script>
<script>
    function leadReport() {
        window.location.href = "<?php echo base_url('leads-report-view');?>";
    }
</script>
<script>
    function expenseReport() {
        window.location.href = "<?php echo base_url('expence-list');?>";
    }
</script>
<script>
    function follupReport() {
        window.location.href = "<?php echo base_url('followup-report');?>";
    }
</script>



<?php echo view('includes/footer'); ?>