<?php

namespace App\Controllers;
class Usermanagment extends BaseController
{
    public function index()
    {
        $id=session()->get('id');
        if($id){
            return view('user_managment');
        }else{
            redirect()->to('/');
        }       
    }
public function user_management()
{
    $db=\Config\Database::connect();
    $builder=$db->table('users');
    $data=$builder->get()->getResultArray();
    // echo 'hello';
    // print_r($data);die();
    if($data){
        return $this->response->setJSON($data);
    }else{
        return $this->response->setJSON(['result'=>0,'message'=>'Failed to load data']);
    }
}

public function promote_employee()
{

    $db=\Config\Database::connect();
    $id=$this->request->getVar('eid');
    $check=$db->table('users');
    $check->where('e_id',$id);
    $edata=$check->get()->getRowArray();
    

    if(empty($edata)){
        $type=$this->request->getVar('type');
        $role_name='';
        if($type==1){
            $role_name='Admin';
        }
        if($type==2){
            $role_name='Trainer';
        }
        $builder=$db->table('employee_details');
        $builder->where('id',$id);
        $e_data=$builder->get()->getRowArray();
        // print_r($id);die();
        if($e_data){
            $username=$e_data['first_name']. " ".$e_data['last_name'];
            $email=$e_data['email'];
            $data=[
                'e_id'=>$id,
                'role'=>$type,
                'role_name'=>$role_name,
                'username'=>$username,
                'email'=>$email,
                'password'=>'welcome123',
                'valid_user'=>1,
                'created_at'=>date('Y-m-d H:i:s')
            ];
            $builder=$db->table('users');
            $insert=$builder->insert($data);

            if($insert){
                return $this->response->setJSON(['result'=>1,'message'=>'Promoted Successfully']);
            }else{
                return $this->response->setJSON(['result'=>0,'message'=>'Failed to promote']);
            }
        }else{
            return $this->response->setJSON(['result'=>0,'message'=>'employee not found']);
        }
    }else{
        return $this->response->setJSON(['result'=>0,'message'=>'Employee Already exist']);
    }
}
public function promote_update()
{
    $id=$this->request->getVar('id');
    $type=$this->request->getVar('type');
    $role_name='';
    if($type==1){
        $role_name='Admin';
    }
    if($type==2){
        $role_name='Trainer';
    }
    $db=\Config\Database::connect();
    $builder=$db->table('users');
    $builder->where('id',$id);
    $insert=$builder->update(['role'=>$type,'role_name'=>$role_name]);
    if($insert){
        return $this->response->setJSON(['result'=>1,'message'=>'Promoted Successfully']);
    }else{
        return $this->response->setJSON(['result'=>0,'message'=>'Failed to promote']);
    }


}
public function user_delete()
{
    $id=$this->request->getVar('id');
    // echo $id;die();
    $db=\Config\Database::connect();
    $builder=$db->table('users');
    $builder->where('id',$id);
    $delete=$builder->delete();
    if($delete){
        return $this->response->setJSON(['result'=>1]);
    }else{
        return $this->response->setJSON(['result'=>0]);
    }
}
}
?>